package com.ifgi.gnc.client;

import com.google.gwt.core.client.GWT;
import com.google.gwt.user.client.Window;
import com.google.gwt.user.client.rpc.AsyncCallback;
import com.google.gwt.user.client.ui.DialogBox;
import com.google.gwt.user.client.ui.Grid;
import com.google.gwt.user.client.ui.HTML;
import com.google.gwt.user.client.ui.VerticalPanel;

public class UserFolder extends VerticalPanel {
	
	final String hostURL = "http://gnc-vs01.uni-muenster.de/god/";
	
	private UserContentServiceAsync userContentSvc = GWT.create(UserContentService.class);

	private static DialogBox infoDialogBox;
	
	private String folderID;
	
	private FolderContent folderContent;
	
	public UserFolder(String folderID) {
		super();
		this.setStylePrimaryName("vertpan");
		
		getUserFolder(folderID);
	}
	
	private void getUserFolder(String folderID) {
		
		this.folderID = folderID;
		
		infoDialogBox = GncGwtToolbox.getSimpleDialogBox("Fetching Folder Content", "Please wait while the folder view gets created");
		
		// Initialize the service proxy.
	    if (userContentSvc == null) {
	    	userContentSvc = GWT.create(UserContentService.class);
	    }

	    // Set up the callback object.
	    AsyncCallback<FolderContent> callback = new AsyncCallback<FolderContent>() {

			@Override
			public void onFailure(Throwable caught) {
				Window.alert("FAILED TO CREATE FOLDER VIEW");
			}

			@Override
			public void onSuccess(FolderContent result) {
				createContentTable(result);
				infoDialogBox.hide();
   			}
	     
	    };

	    // Make the call to the stock price service.
	    userContentSvc.getFolder(folderID, callback);
	}
	
	private void createContentTable (FolderContent folderContent){
		this.folderContent = folderContent;
		
		Grid contentGrid = new Grid(folderContent.getNameArrayList().size() + 1, 3);
		
		contentGrid.setWidget(0, 0, GncGwtToolbox.createStyledLabel("Filename", "contabhead"));
		contentGrid.setWidget(0, 1, GncGwtToolbox.createStyledLabel("Created", "contabhead"));
		contentGrid.setWidget(0, 2, GncGwtToolbox.createStyledLabel("Filesize", "contabhead"));

		int gridIndex = 1;
		int arrayIndex = 0;
		for (String file : folderContent.getNameArrayList()){
			contentGrid.setWidget(gridIndex, 0, new HTML("<a href="+"\""+hostURL+folderID+"/"+folderContent.getNameArrayList().get(arrayIndex)+"\""+" target=\"_blank\">"+folderContent.getNameArrayList().get(arrayIndex)+"</a>"));
			contentGrid.getWidget(gridIndex, 0).setStylePrimaryName("contab");
			contentGrid.setWidget(gridIndex, 1, GncGwtToolbox.createStyledLabel(folderContent.getDateArrayList().get(arrayIndex), "contab"));
			contentGrid.setWidget(gridIndex, 2, GncGwtToolbox.createStyledLabel(folderContent.getSizeArrayList().get(arrayIndex), "contab"));
			
			gridIndex++;
			arrayIndex++;
		}
		
		this.add(contentGrid);
		
	} 
}
