package com.ifgi.gnc.server;

import javax.crypto.Cipher;
import javax.crypto.SecretKey;
import javax.crypto.SecretKeyFactory;
import javax.crypto.spec.PBEKeySpec;
import javax.crypto.spec.PBEParameterSpec;

import com.google.gwt.user.server.Base64Utils;





public class CryptingActivation {
	final private transient static String password = "andchrdam";
	  final private transient byte [] salt = { (byte) 0xc9, (byte) 0xc9,(byte) 0xc9,(byte) 0xc9,(byte) 0xc9,(byte) 0xc9,(byte) 0xc9,(byte) 0xc9};
	  final int iterations = 3;

	  protected CryptingActivation() {
	  }

	  /** instance */
	  private static CryptingActivation instance;

	  /** Singleton Factory
	   * @return instance
	   */
	  public static CryptingActivation getInstance () {
	    if (instance == null) {
	      instance = new CryptingActivation ();
	    }
	    return instance;

	  }


	  /** Notwendige Instanczen */
	  private Cipher encryptCipher;
	  private Cipher decryptCipher;
	  private Base64Utils enDEcoder = new Base64Utils();
	  

	  /** Verwendete Zeichendecodierung */
	  private String charset = "UTF16";

	  /**
	   * Initialisiert den Verschlsselungsmechanismus
	   * @param pass char[]
	   * @param salt byte[]
	   * @param iterations int
	   * @throws SecurityException
	   */
	  public void init () throws SecurityException {
	    try {
	      final PBEParameterSpec ps = new PBEParameterSpec(salt, 20);
	      final SecretKeyFactory kf = SecretKeyFactory.getInstance("PBEWithMD5AndDES");
	      final SecretKey k = kf.generateSecret(new PBEKeySpec(password.toCharArray()));
	      encryptCipher = Cipher.getInstance("PBEWithMD5AndDES/CBC/PKCS5Padding");
	      encryptCipher.init (Cipher.ENCRYPT_MODE, k, ps);
	      decryptCipher = Cipher.getInstance("PBEWithMD5AndDES/CBC/PKCS5Padding");
	      decryptCipher.init (Cipher.DECRYPT_MODE, k, ps);
	    }
	    catch (Exception e) {
	      throw new SecurityException("Could not initialize CryptoLibrary: " +
	                                  e.getMessage());
	    }
	  }

	  /**
	   * Verschlsselt eine Zeichenkette
	   *
	   * @param str Description of the Parameter
	   * @return String the encrypted string.
	   * @exception SecurityException Description of the Exception
	   */
	  public synchronized String encrypt(String str) throws SecurityException {
	    try {
	      byte[] b = str.getBytes(this.charset);
	      byte[] enc = encryptCipher.doFinal(b);
	      return enDEcoder.toBase64(enc);
	    }
	    catch (Exception e){
	      throw new SecurityException("Could not encrypt: " + e.getMessage());
	    }

	  }

	  /**
	   * Entschlsselt eine Zeichenkette, welche mit der Methode encrypt
	   * verschlsselt wurde.
	   *
	   * @param str Description of the Parameter
	   * @return String the encrypted string.
	   * @exception SecurityException Description of the Exception
	   */
	  public synchronized String decrypt(String str) throws SecurityException  {
	    try {
	      byte[] dec = enDEcoder.fromBase64(str);
	      byte[] b = decryptCipher.doFinal(dec);
	      return new String(b, this.charset);
	    }
	    catch (Exception e) {
	      throw new SecurityException("Could not decrypt: " + e.getMessage());
	    }
	  }

	  public static String getPassword() {
		return password;
	}

//	public static void main (final String [] ignored) {
//		CryptingActivation man = CryptingActivation.getInstance();
//	    man.init();
//	    final String encrypted = man.encrypt("Andres");
//	    System.out.println ("Verschlsselt :"+encrypted);
//	    final String decrypted = man.decrypt (encrypted);
//	    System.out.println("Entschlsselt :"+decrypted);
//	  }

}
