package com.ifgi.gnc.server;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.ArrayList;

import javax.swing.text.html.HTMLEditorKit;
import javax.swing.text.html.parser.ParserDelegator;

import com.google.gwt.user.server.rpc.RemoteServiceServlet;
import com.ifgi.gnc.client.FolderContent;
import com.ifgi.gnc.client.UserContentService;

public class UserContentServiceImpl extends RemoteServiceServlet implements
		UserContentService {
	
	final String indexHost = "http://gnc-vs01.uni-muenster.de/god/";
	
	private ArrayList<String> tempArrayListFromIndexFile = new ArrayList<String>();
	
	@Override
	public FolderContent getFolder(String folderID)  {
				
	    URL indexURL = null;
		try {
			indexURL = new URL( indexHost + folderID);
		} catch (MalformedURLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		BufferedReader in = null;
		try {
			in = new BufferedReader(
					new InputStreamReader(
					indexURL.openStream()));
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		HTMLEditorKit.ParserCallback callback = 
		      new HTMLEditorKit.ParserCallback () {
		        public void handleText(char[] data, int pos) {
		            tempArrayListFromIndexFile.add(new String(data));
		       	}
			  };

		    
		try {
			new ParserDelegator().parse(in, callback, false);
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		//remove overhead elements
		tempArrayListFromIndexFile.remove(0);
		tempArrayListFromIndexFile.remove(0);
		tempArrayListFromIndexFile.remove(0);
		tempArrayListFromIndexFile.remove(0);
		tempArrayListFromIndexFile.remove(0);
		tempArrayListFromIndexFile.remove(0);
		
		//create FolderContent Object
		ArrayList<String> nal = new ArrayList<String>();
		ArrayList<String> dal = new ArrayList<String>();
		ArrayList<String> sal = new ArrayList<String>();

		while (!tempArrayListFromIndexFile.isEmpty()){
			nal.add(tempArrayListFromIndexFile.get(0));
			tempArrayListFromIndexFile.remove(0);
			dal.add(tempArrayListFromIndexFile.get(0));
			tempArrayListFromIndexFile.remove(0);
			sal.add(tempArrayListFromIndexFile.get(0));
			tempArrayListFromIndexFile.remove(0);
		}
		
		ArrayList<Integer> deleteIndex = new ArrayList<Integer>();
		for (String filename: nal){
			if ( filename.indexOf(".txt") != -1 || filename.indexOf(".tif") != -1 || filename.indexOf(".xml") != -1){
				
			} else {
				deleteIndex.add(0, new Integer(nal.indexOf(filename)));
				
			}
		}
				
		for (Integer delIndex : deleteIndex){
			nal.remove(delIndex.intValue());
			dal.remove(delIndex.intValue());
			sal.remove(delIndex.intValue());
		}
				
	      
		return new FolderContent(nal, dal, sal);
	}

}
