package com.ifgi.gnc.server.writer;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;

import com.ifgi.gnc.client.BBox;
import com.ifgi.gnc.client.Product;
import com.ifgi.gnc.server.BBoxXY;
import com.ifgi.gnc.constants.GODConstants;
import com.ifgi.gnc.server.GODUtil;
import com.ifgi.gnc.server.ProductInstance;

public class DSSFScriptWriter extends ScriptWriter{
	@Override
	protected void writeScript(ProductInstance pi) throws IOException, InterruptedException {

		
		Product metadata = pi.getMetaData();
		String filename = GODUtil.getLongFileName(pi.getTs());
		String outputFilename = this.scriptFile.getName();
		outputFilename = outputFilename.substring(0, outputFilename.length()-4);
		BBox bBox = pi.getBBox();
		BBoxXY bBoxXY = GODUtil.convertBBoxLatLonToMapXY(bBox, "lst_whole");
		String outPathStr = this.outputDir.getAbsolutePath();
		String outDriveStr = outPathStr.substring(0, 2);
		String outDirStr = outPathStr.substring(3, outPathStr.length());
		String[] tempFiles = {
				"fdssf_africa%shortfilename1%.*",
				"nafr_%shortfilename1%.*",
				"safr_%shortfilename1%.*",
				"S-LSA_-HDF5_LSASAF_MSG_DSSF_NAfr_*.*",
				"S-LSA_-HDF5_LSASAF_MSG_DSSF_SAfr_*.*"
		};
		
		writeGeneralTemplate(filename,
				outputFilename,
				bBoxXY,
				outDriveStr,
				outDirStr,
				constants.SAF_INPUT_DRIVE,
				constants.SAF_INPUT_DIRECTORY,
				"africa_dssfimport",
				"dssf_africa",
				pi.getFormat(),
				tempFiles,
				"%InputDrive%\\%InputDir%\\S-LSA_-HDF5_LSASAF_MSG_DSSF_NAfr_%shortfilename1%.bz2");
	}
}
