package com.ifgi.gnc.server.writer;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;

import com.ifgi.gnc.client.BBox;
import com.ifgi.gnc.client.Product;
import com.ifgi.gnc.server.BBoxXY;
import com.ifgi.gnc.constants.GODConstants;
import com.ifgi.gnc.server.GODUtil;
import com.ifgi.gnc.server.ProductInstance;

public class FIRAScriptWriter extends ScriptWriter{
	@Override
	protected void writeScript(ProductInstance pi) throws IOException, InterruptedException {

		
		Product metadata = pi.getMetaData();
		String filename = GODUtil.getLongFileName(pi.getTs());
		String outputFilename = this.scriptFile.getName();
		outputFilename = outputFilename.substring(0, outputFilename.length()-4);
		BBox bBox = pi.getBBox();
		BBoxXY bBoxXY = GODUtil.convertBBoxLatLonToMapXY(bBox, "LatlonWGS84");
		String outPathStr = this.outputDir.getAbsolutePath();
		String outDriveStr = outPathStr.substring(0, 2);
		String outDirStr = outPathStr.substring(3, outPathStr.length());
		String dayNumber = GODUtil.getDayNumber(pi.getTs());
		String[] tempFiles = {
				"L-000-MSG2__-MPEF________-FIRA_____-000001___-%shortfilename1%-__*",
				"country_02.*",
				"country_samecode.*",
				"fire.*",
				"fire_points.*",
				"fire_fira.mpv"
		};
		
		writeGeneralTemplate(filename,
				outputFilename,
				bBoxXY,
				outDriveStr,
				outDirStr,
				constants.MPEF_INPUT_DRIVE,
				constants.MPEF_INPUT_DIRECTORY,
				"fira_import",
				"fire_fira",
				pi.getFormat(),
				tempFiles,
				"%InputDrive%\\%InputDir%\\L-000-MSG2__-MPEF________-FIRA_____-000001___-%shortfilename1%-__");
	}
}
