package com.ifgi.gnc.server.writer;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;

import com.ifgi.gnc.client.BBox;
import com.ifgi.gnc.client.Product;
import com.ifgi.gnc.server.BBoxXY;
import com.ifgi.gnc.constants.GODConstants;
import com.ifgi.gnc.server.GODUtil;
import com.ifgi.gnc.server.ProductInstance;

public class MODISScriptWriter extends ScriptWriter{
	@Override
	protected void writeScript(ProductInstance pi) throws IOException, InterruptedException {

		
		Product metadata = pi.getMetaData();
		String filename = GODUtil.getLongFileName(pi.getTs());
		String outputFilename = this.scriptFile.getName();
		outputFilename = outputFilename.substring(0, outputFilename.length()-4);
		BBox bBox = pi.getBBox();
		BBoxXY bBoxXY = GODUtil.convertBBoxLatLonToMapXY(bBox, "lst_whole");
		String outPathStr = this.outputDir.getAbsolutePath();
		String outDriveStr = outPathStr.substring(0, 2);
		String outDirStr = outPathStr.substring(3, outPathStr.length());
		String dayNumber = GODUtil.getDayNumber(pi.getTs());
		String[] tempFiles = {
				"MOD14.P"+filename.substring(0,4)+dayNumber+".*",
				"fire"+filename.substring(0,4)+dayNumber+"*"
		};
		
		writeGeneralTemplateDayNumber(filename,
				outputFilename,
				bBoxXY,
				outDriveStr,
				outDirStr,
				constants.MODIS_INPUT_DRIVE,
				constants.MODIS_INPUT_DIRECTORY,
				"modis_firestart",
				"fire",
				dayNumber,
				pi.getFormat(),
				tempFiles,
				"%InputDrive%\\%InputDir%\\MOD14.P20??%9.????.hdf.gz");
	}
}
