package com.ifgi.gnc.testing;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.logging.Logger;

import com.ifgi.gnc.server.ProductInstance;

public class DummyScriptWriter {

	private static Logger logger = Logger.getLogger("DummyScriptWriter_log");
	
	public static void createScript(ProductInstance pi, String scriptFileStr, String scriptDirStr, String outputDirStr) {
		String fullResultPath = outputDirStr + scriptFileStr + ".txt";
		String fullScriptPath = scriptDirStr + scriptFileStr + ".bat";
		File scriptFile = new File(fullScriptPath);
		try {
			PrintWriter pw = new PrintWriter(new BufferedWriter(new FileWriter(scriptFile)));
			pw.println("echo This is a placeholder file for a georeferenced image with the following properties: > " + fullResultPath);
			pw.println("echo Product: " + pi.getMetaData().getName() + " >> " + fullResultPath);
			pw.println("echo BBox: " + pi.getBBox() + " >> " + fullResultPath);
			pw.println("echo Timestamp: " + pi.getTs() + " >> " + fullResultPath);
			pw.println("echo Image format: " + pi.getFormat() + " >> " + fullResultPath);
			pw.close();
		} catch (IOException e) {
			logger.warning("Unable to create writer for file: " + fullScriptPath);
		}
	}
}
