package com.ifgi.gnc.testing;

import java.io.File;
import java.io.IOException;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;

import com.ifgi.gnc.client.BBox;
import com.ifgi.gnc.client.Product;
import com.ifgi.gnc.server.BBoxXY;
import com.ifgi.gnc.server.GODUtil;
import com.ifgi.gnc.server.ProductInstance;
import com.ifgi.gnc.server.writer.ScriptWriter;

// console to test ScriptWriter
public class ScriptTest {
	public static void main(String[] args){
//		testBBox();
		testScriptWriter();
		System.out.println("done");
	}
	
	private static void testBBox(){
		BBox bbox = new BBox(27.5044472222, 30.9537281890, 1.6290877637, -11.9708313892);
		try{
			System.out.println("converting");
			BBoxXY bboxXY = GODUtil.convertBBoxLatLonToMapXY(bbox, "lst_whole");
//			BBoxXY bboxXY = GODUtil.convertBBoxLatLonToRowCol(bbox, "fire_template");
			
			System.out.println("botleft.X="+bboxXY.getBottomLeftX());
			System.out.println("botleft.Y="+bboxXY.getBottomLeftY());
			System.out.println("topright.X="+bboxXY.getTopRightX());
			System.out.println("topright.Y="+bboxXY.getTopRightY());

//			System.out.println("botleft.COL="+bboxXY.getBottomLeftX());
//			System.out.println("botleft.ROW="+bboxXY.getBottomLeftY());
//			System.out.println("topright.COL="+bboxXY.getTopRightX());
//			System.out.println("topright.ROW="+bboxXY.getTopRightY());
		} catch(Exception e){
			e.printStackTrace();
		}
	}

	private static void testScriptWriter() {
		Calendar cal = Calendar.getInstance();
		
//		cal.set(2010, 0, 21);
//		cal.set(Calendar.HOUR_OF_DAY, 0);
//		cal.set(Calendar.MINUTE, 0);
//		runScriptTest("Africa_Albedo_201001210000_bbox.bat","Africa_SAF_Albedo", cal);
//		
//		cal = Calendar.getInstance();
//		cal.set(2010, 0, 21);
//		cal.set(Calendar.HOUR_OF_DAY, 0);
//		cal.set(Calendar.MINUTE, 0);
//		runScriptTest("Africa_DSSF_201001210000_bbox.bat","Africa_SAF_DSSF", cal);
//		
//		cal = Calendar.getInstance();
//		cal.set(2010, 0, 21);
//		cal.set(Calendar.HOUR_OF_DAY, 0);
//		cal.set(Calendar.MINUTE, 0);
//		runScriptTest("Africa_DSLF_201001210000_bbox.bat","Africa_SAF_DSLF", cal);
		
		cal = Calendar.getInstance();
		cal.set(2010, 0, 21);
		cal.set(Calendar.HOUR_OF_DAY, 0);
		cal.set(Calendar.MINUTE, 0);
		runScriptTest("Africa_FVC_201001210000_bbox.bat","Africa_SAF_FVC", cal);
		
		cal = Calendar.getInstance();
		cal.set(2010, 0, 21);
		cal.set(Calendar.HOUR_OF_DAY, 0);
		cal.set(Calendar.MINUTE, 0);
		runScriptTest("Africa_LAI_201001210000_bbox.bat","Africa_SAF_LAI", cal);
		
		cal = Calendar.getInstance();
		cal.set(2010, 0, 21);
		cal.set(Calendar.HOUR_OF_DAY, 0);
		cal.set(Calendar.MINUTE, 0);
		runScriptTest("Africa_LST_201001210000_bbox.bat","Africa_SAF_LST", cal);
		
		cal = Calendar.getInstance();
		cal.set(2010, 0, 21);
		cal.set(Calendar.HOUR_OF_DAY, 0);
		cal.set(Calendar.MINUTE, 0);
		runScriptTest("Africa_fAPAR_201001210000_bbox.bat","Africa_SAF_fAPAR", cal);
		
		cal = Calendar.getInstance();
		cal.set(2010, 0, 17);
		cal.set(Calendar.HOUR_OF_DAY, 0);
		cal.set(Calendar.MINUTE, 0);
		runScriptTest("Africa_MODIS_201001170000_bbox.bat","MODIS_Fire", cal);
		
		cal = Calendar.getInstance();
		cal.set(2009, 11, 18);//200912181300
		cal.set(Calendar.HOUR_OF_DAY, 13);
		cal.set(Calendar.MINUTE, 0);
		runScriptTest("MPEF_FIRA_200912181300_bbox.bat","MPEF_FIRA", cal);
	}
	
	private static void runScriptTest(String scriptFileNameStr, String productName, Calendar cal){
		Product metadata = new Product();
		
		BBox bbox = new BBox(27.5044472222, 30.9537281890, 1.6290877637, -11.9708313892);
		
		metadata.setbBox(bbox);
		
		ArrayList<String> fileFormats = new ArrayList<String>();
		fileFormats.add("tif");
		metadata.setFileFormats(fileFormats);
		
		metadata.setInfo("suns radiation flux");
		metadata.setName(productName);
		metadata.setUpdateInterval(1800000);
		
		Timestamp ts = new Timestamp(cal.getTimeInMillis());
		
		ProductInstance pi = new ProductInstance(metadata, bbox, ts, "tif");
		
		ScriptWriter sw = ScriptWriter.getScriptWriter(pi.getMetaData().getName());
		String scriptDirStr = "C:\\Users\\Jafar.R.Hafiz\\Documents\\program\\ilwis\\africa_albedo";
		String outputDirStr = "C:\\Users\\Jafar.R.Hafiz\\Documents\\program\\ilwis\\africa_albedo\\output";
		try{
			sw.createScript(pi, scriptFileNameStr, scriptDirStr, outputDirStr);
		}catch(Exception e){
			e.printStackTrace();
		}
		
		System.out.println("runScriptTest done");
	}
}
